require 'time'
require 'json'
require 'restforce'

require_relative 'afc_salesforce/data_truncator'
require_relative 'afc_salesforce/configuration'

require_relative 'afc_salesforce/tools/utilities'
require_relative 'afc_salesforce/tools/validation'
require_relative 'afc_salesforce/tools/validation/rule/email'
require_relative 'afc_salesforce/tools/validation/rule/length'
require_relative 'afc_salesforce/tools/validation/rule/matches'
require_relative 'afc_salesforce/tools/validation/rule/not_empty'
require_relative 'afc_salesforce/tools/validation/rule/not_nil'
require_relative 'afc_salesforce/tools/validation/rule/numeric'
require_relative 'afc_salesforce/tools/validation/rule/phone'
require_relative 'afc_salesforce/tools/validation/rule/regular_expression'
require_relative 'afc_salesforce/tools/validation/rule/instance_of'

require_relative 'afc_salesforce/models/concerns/type_setter'
require_relative 'afc_salesforce/models/base'
require_relative 'afc_salesforce/models/account'
require_relative 'afc_salesforce/models/asset'
require_relative 'afc_salesforce/models/contact'
require_relative 'afc_salesforce/models/income'
require_relative 'afc_salesforce/models/lead'

require_relative 'afc_salesforce/base'
require_relative 'afc_salesforce/account'
require_relative 'afc_salesforce/additional_income'
require_relative 'afc_salesforce/asset'
require_relative 'afc_salesforce/borrower'
require_relative 'afc_salesforce/lead'

require_relative 'afc_salesforce/forms/long_purchase'
require_relative 'afc_salesforce/forms/long_refinance'
require_relative 'afc_salesforce/forms/short_lead'
require_relative 'afc_salesforce/forms/lead_plus'

require_relative 'afc_salesforce/version'

module AFCSalesforce
  class << self
    attr_accessor :configuration
  end

  def self.configuration
    @configuration ||= Configuration.new
  end

  def self.reset
    @configuration = Configuration.new
  end

  def self.configure
    yield(configuration)
  end
end
