module AFCSalesforce
  class Account < Base
    attr_accessor :appraised_value,
                  :approximate_value,
                  :call_status__c,
                  :condo_type,
                  :date_of_last_appraisal,
                  :date_of_purchase,
                  :dm_call,
                  :email,
                  :endorser,
                  :first_mortgage_balance,
                  :first_mortgage_interest_rate,
                  :first_mortgage_payment,
                  :former_bankruptcy,
                  :former_foreclosure,
                  :hoa_dues,
                  :initial_purchase_price,
                  :internet_source,
                  :is_escrowed,
                  :is_va_eligible,
                  :last_appraisal__c,
                  :loan_purpose,
                  :loan_type,
                  :monthly_insurance,
                  :monthly_taxes,
                  :name,
                  :number_of_units,
                  :occupancy_type,
                  :original_endorser,
                  :original_source,
                  :phone,
                  :program_type,
                  :property_acre_count,
                  :property_bathroom_count,
                  :property_bedroom_count,
                  :property_city,
                  :property_close_date,
                  :property_down_payment,
                  :property_price,
                  :property_state,
                  :property_street,
                  :property_type,
                  :property_zip,
                  :purchase_close_date,
                  :purchase_date,
                  :realtor_email,
                  :realtor_name,
                  :realtor_phone,
                  :realtor_sign_up_date,
                  :refinance_loan_type,
                  :refinance_reason,
                  :residence_type,
                  :second_mortgage,
                  :second_mortgage_balance,
                  :second_mortgage_date_opened,
                  :second_mortgage_payment,
                  :second_mortgage_rate,
                  :session_uuid,
                  :source,
                  :square_feet,
                  :subject_property_city,
                  :subject_property_state,
                  :working_with_realtor,
                  :x2nd_mortgage_date_opened__c

    def to_h
      AFCSalesforce::Models::Account.new(
        acres__c: @property_acre_count,
        appraised_value__c: @appraised_value,
        approximate_value__c: @approximate_value,
        bathrooms__c: @property_bathroom_count,
        bedrooms__c: @property_bedroom_count,
        billingcity: @property_city,
        billingpostalcode: @property_zip,
        billingstate: @property_state,
        billingstreet: @property_street,
        call_status__c: @call_status__c,
        condo_type__c: @condo_type,
        dm_call__c: @dm_call,
        down_payment__c: @property_down_payment,
        endorser__c: @endorser,
        escrowed__c: @is_escrowed,
        former_bankruptcy__c: @former_bankruptcy,
        former_foreclosure__c: @former_foreclosure,
        hoa_dues__c: @hoa_dues,
        internet_source__c: @internet_source,
        last_appraisal__c: @date_of_last_appraisal,
        loan_purpose__c: @loan_purpose,
        loan_type__c: @refinance_loan_type,
        monthly_insurance__c: @monthly_insurance,
        monthly_taxes__c: @monthly_taxes,
        name: @name,
        new_purchase_price__c: @property_price,
        number_of_units__c: @number_of_units,
        occupancy_type__c: @occupancy_type,
        original_endorser__c: @original_endorser,
        original_purchase_price__c: @initial_purchase_price,
        original_source__c: @original_source,
        phone: @phone,
        program_type__c: @program_type,
        property_type__c: @property_type,
        puchase_close_date__c: @purchase_close_date,
        purchase_date__c: @purchase_date,
        realtor_email__c: @realtor_email,
        realtor_name__c: @realtor_name,
        realtor_phone_number__c: @realtor_phone,
        refinance_purpose__c: @refinance_reason,
        residence_type__c: @residence_type,
        session_uuid__c: @session_uuid,
        source__c: @source,
        square_feet__c: @square_feet,
        subject_property_city__c: @subject_property_city,
        subject_property_state__c: @subject_property_state,
        type__c: @loan_type,
        va_eligible__c: @is_va_eligible,
        working_with_realtor__c: @working_with_realtor,
        x1st_mortgage_balance__c: @first_mortgage_balance,
        x1st_mortgage_payment__c: @first_mortgage_payment,
        x1st_mortgage_rate__c: @first_mortgage_interest_rate,
        x2nd_mortgage__c: @second_mortgage,
        x2nd_mortgage_balance__c: @second_mortgage_balance,
        x2nd_mortgage_date_opened__c: @second_mortgage_date_opened,
        x2nd_mortgage_payment__c: @second_mortgage_payment,
        x2nd_mortgage_rate__c: @second_mortgage_rate
      ).to_h
    end
  end
end
