module AFCSalesforce
  class DataTruncator
    class << self
      MAX_VALUE = {
        :'Bathrooms__c' => 99,
        :'Bedrooms__c' => 99,
        :'Down_Payment__c' => 999999,
      }

      MAX_LENGTH = {
        :'Actual_Mailing_City__c' => 40,
        :'BillingCity' => 40,
        :'Bor_Company_Name__c' => 50,
        :'Email' => 320,
        :'FirstName' => 24,
        :'LastName' => 24,
        :'Name' => 80,
        :'MailingCity' =>  40,
        :'Phone' => 40,
        :'Realtor_Name__c' => 50,
        :'Subject_Property_City__c' => 50,
      }

      def truncate_hash(hash)
        hash.inject({}) { |hash, (key, value)| hash[key] = truncate_value(key, value); hash }
      end


      private


      def truncate_value(key, value)
        max = MAX_VALUE[key] || MAX_LENGTH[key]
        return value unless max

        if value.is_a? String
          value[0...max]
        elsif value.is_a?(Float) || value.is_a?(Integer)
          [value, max].min
        else
          value
        end
      end
    end
  end
end
