module AFCSalesforce
  class Lead < Base
    attr_accessor :city,
                  :company,
                  :email,
                  :endorser,
                  :first_name,
                  :internet_source,
                  :last_name,
                  :original_endorser,
                  :original_source,
                  :page_url,
                  :page_variant,
                  :phone,
                  :redirect_url,
                  :search_adgroup,
                  :search_campaign,
                  :search_keyword,
                  :search_source,
                  :session_uuid,
                  :source,
                  :state,
                  :type,
                  :unbounce_page_id,
                  :working_with_realtor,
                  :zip

    def to_h
      AFCSalesforce::Models::Lead.new(
        city: @city,
        company: @company,
        email: @email,
        endorser__c: @endorser,
        firstname: @first_name,
        internetsource__c: @internet_source,
        lastname: @last_name,
        original_endorser__c: @original_endorser,
        original_source__c: @original_source,
        page_url__c: @page_url,
        page_variant__c: @page_variant,
        phone: @phone,
        postalcode: @zip,
        redirect_url__c: @redirect_url,
        searchadgroup__c: @search_adgroup,
        searchcampaign__c: @search_campaign,
        searchkeyword__c: @search_keyword,
        searchsource__c: @search_source,
        session_uuid__c: @session_uuid,
        source__c: @source,
        state: @state,
        type__c: @type,
        unbounce_page_id__c: @unbounce_page_id,
        working_with_realtor__c: @working_with_realtor
      ).to_h
    end
  end
end
