module AFCSalesforce
  module Models
    class Account < AFCSalesforce::Models::Base

      attr_accessor :account_number,
                    :account_source,
                    :acres__c,
                    :adjusted_gross_income__c,
                    :aha_appt__c,
                    :aha_appt_date__c,
                    :aha_csr__c,
                    :aha_lead__c,
                    :aha_listing__c,
                    :aha_property_address__c,
                    :aha_property_city__c,
                    :aha_property_state__c,
                    :aha_property_zip__c,
                    :aha_purchase_price__c,
                    :aha_realtor__c,
                    :aha_status__c,
                    :annual_revenue,
                    :application_status__c,
                    :application_status_timestamp__c,
                    :appointment__c,
                    :appraisal_objection_date__c,
                    :appraisal_ordered__c,
                    :appraisal_received__c,
                    :appraised_value__c,
                    :approximate_value__c,
                    :bankruptcy_date__c,
                    :bathrooms__c,
                    :bedrooms__c,
                    :billingcity,
                    :billingpostalcode,
                    :billingstate,
                    :billingstreet,
                    :broker_commission__c,
                    :buyer_agency_date__c,
                    :buyer_to_contract__c,
                    :call_status__c,
                    :cap__c,
                    :ccd_closed_date__c,
                    :ccd_closed_lost_reason__c,
                    :ccd_closing_status__c,
                    :client_docs__c,
                    :close_date_w_aha__c,
                    :closed_docs__c,
                    :closed_purchase_val__c,
                    :closed_with_aha__c,
                    :closedgrosscommission__c,
                    :cnd_date_stamp__c,
                    :cndforcredit__c,
                    :commission_to_broker__c,
                    :condo_type__c,
                    :contract_to_close__c,
                    :created_by,
                    :credit_agent__c,
                    :credit_care_status__c,
                    :credit_repair_referral__c,
                    :csr__c,
                    :current_rent__c,
                    :days_old__c,
                    :description,
                    :dm_call__c,
                    :dng_reason__c,
                    :down_payment__c,
                    :down_payment_notes__c,
                    :endorser__c, :escrowed__c,
                    :est_close_date_w_aha__c,
                    :estimated_date_to_complete_cap__c,
                    :estimated_time_to_complete_program__c,
                    :fax,
                    :filedataid__c,
                    :flat_fee__c,
                    :foreclosure_date__c,
                    :former_bankruptcy__c,
                    :former_foreclosure__c,
                    :gross_commission__c,
                    :gross_commission_all__c,
                    :hoa_dues__c,
                    :if_va_eligible_have_they_used_it__c,
                    :industry,
                    :inside_realtor__c,
                    :inspection_objection_date__c,
                    :internet_lead__c,
                    :internet_source__c,
                    :is_customer_portal,
                    :jigsaw,
                    :last_appraisal__c,
                    :last_date_listed__c,
                    :last_modified_by,
                    :last_price_listed_for__c,
                    :lead_sent_to_sqlbyte__c,
                    :lead_type__c,
                    :listing_agent_broker__c,
                    :listing_agent_cell_phone__c,
                    :listing_agent_company__c,
                    :listing_agent_email__c,
                    :listing_agent_work_phone__c,
                    :listing_contract_date__c, :loan_commitment_date__c,
                    :loan_purpose__c,
                    :loan_type__c,
                    :los_issues__c,
                    :median_score__c,
                    :monthly_budget__c,
                    :monthly_insurance__c,
                    :monthly_taxes__c,
                    :mortgage_notes__c,
                    :name,
                    :new_file_to_buyer__c,
                    :new_purchase_price__c,
                    :not_a_lead__c,
                    :number_of_units__c,
                    :numberofemployees,
                    :occupancy_type__c,
                    :original_endorser__c,
                    :original_purchase_price__c,
                    :original_source__c,
                    :outside_financing__c,
                    :outside_real_estate_company__c,
                    :owner,
                    :owner_from_original_lead__c,
                    :ownercell__c,
                    :ownership,
                    :parent,
                    :pending_docs__c,
                    :phone,
                    :previous_year_30_day_mortgage_lates__c,
                    :price_range__c,
                    :primary_borrower_email__c,
                    :primary_borrower_name__c,
                    :primary_borrower_phone__c,
                    :processor__c, :program_coordinator__c,
                    :program_type__c,
                    :property_type__c,
                    :puchase_close_date__c,
                    :purchase_contract_date__c,
                    :rating,
                    :realtor_email__c, :realtor_name__c,
                    :realtor_phone_number__c,
                    :referral_commission__c,
                    :refinance_purpose__c, :related_file__c,
                    :renting_current_home__c,
                    :rescore_date__c,
                    :rescore_done__c,
                    :residence_type__c,
                    :score_update__c,
                    :searchadgroup__c,
                    :searchcampaign__c,
                    :searchkeyword__c,
                    :searchsource__c,
                    :selling_current_home__c,
                    :session_uuid__c,
                    :shipping_address,
                    :sic,
                    :sic_description,
                    :sign_off_location__c,
                    :sign_up_date__c, :source__c,
                    :site,
                    :square_feet__c,
                    :subject_property_address__c,
                    :subject_property_city__c, :subject_property_zip__c,
                    :subject_property_state__c,
                    :ticker_symbol,
                    :title_address__c,
                    :title_closer_name__c,
                    :title_company_name__c,
                    :title_email__c,
                    :title_fax__c,
                    :title_phone__c,
                    :title_state__c,
                    :title_zip__c,
                    :type,
                    :type__c,
                    :va_eligible__c,
                    :velo__apex_context__c,
                    :velo__is_synced_with_velocify__c,
                    :velo__lead360recordid__c,
                    :velo__leads360_milestoneid__c,
                    :velo__record_history__c,
                    :velo__salesforce_owner_name__c,
                    :velo__salesforce_owner_profilename__c,
                    :velo__salesforce_owner_role_name__c, :scanning_complete__c,
                    :velo__time_zone__c,
                    :velo_last_action_date__c,
                    :velocify_owner__c,
                    :website,
                    :whenselling__c,
                    :working_with_realtor__c,
                    :x1_referral_date__c,
                    :x1_referral_name__c,
                    :x1_referral_phone__c,
                    :x1st_mortgage_balance__c,
                    :x1st_mortgage_payment__c,
                    :x1st_mortgage_rate__c,
                    :x2_referral_date__c,
                    :x2_referral_name__c,
                    :x2_referral_phone__c,
                    :x2nd_mortgage__c,
                    :x2nd_mortgage_balance__c,
                    :x2nd_mortgage_date_opened__c,
                    :x2nd_mortgage_payment__c,
                    :x2nd_mortgage_rate__c,
                    :x3_referral_date__c,
                    :x3_referral_name__c,
                    :x3_referral_phone__c,
                    :x4_referral_date__c,
                    :x4_referral_name__c,
                    :x4_referral_phone__c


      set_as_float :adjusted_gross_income__c,
                   :annual_revenue,
                   :appraised_value__c,
                   :approximate_value__c,
                   :broker_commission__c,
                   :buyer_to_contract__c,
                   :closed_purchase_val__c,
                   :closedgrosscommission__c,
                   :commission_to_broker__c,
                   :current_rent__c,
                   :down_payment__c,
                   :flat_fee__c,
                   :gross_commission__c,
                   :hoa_dues__c,
                   :hoa_dues__c,
                   :last_price_listed_for__c,
                   :monthly_budget__c,
                   :monthly_insurance__c,
                   :monthly_insurance__c,
                   :monthly_taxes__c,
                   :monthly_taxes__c,
                   :new_purchase_price__c,
                   :original_purchase_price__c,
                   :square_feet__c,
                   :square_feet__c,
                   :x1st_mortgage_balance__c,
                   :x1st_mortgage_payment__c,
                   :x1st_mortgage_rate__c,
                   :x2nd_mortgage_balance__c,
                   :x2nd_mortgage_payment__c,
                   :x2nd_mortgage_rate__c, :acres__c

      set_as_integer :aha_purchase_price__c,
                     :bathrooms__c,
                     :bedrooms__c,
                     :median_score__c,
                     :new_purchase_price__c,
                     :numberofemployees,
                     :score_update__c,
                     :velo__leads360_milestoneid__c

      set_as_date :aha_appt_date__c,
                  :application_status_timestamp__c,
                  :appointment__c,
                  :appraisal_objection_date__c,
                  :appraisal_ordered__c, :appraisal_received__c,
                  :bankruptcy_date__c,
                  :buyer_agency_date__c,
                  :ccd_closed_date__c,
                  :client_docs__c, :close_date_w_aha__c,
                  :closed_docs__c,
                  :cnd_date_stamp__c,
                  :est_close_date_w_aha__c,
                  :estimated_date_to_complete_cap__c,
                  :foreclosure_date__c,
                  :inspection_objection_date__c,
                  :last_appraisal__c,
                  :last_date_listed__c,
                  :listing_contract_date__c,
                  :loan_commitment_date__c, :pending_docs__c,
                  :puchase_close_date__c,
                  :puchase_close_date__c,
                  :purchase_contract_date__c,
                  :purchase_date__c,
                  :rescore_date__c,
                  :sign_up_date__c,
                  :velo_last_action_date__c,
                  :x1_referral_date__c,
                  :x2_referral_date__c,
                  :x3_referral_date__c,
                  :x4_referral_date__c

      set_as_boolean :escrowed__c,
                     :x2nd_mortgage__c

      def to_h
        salesforce_hash = {
          :"AccountNumber"                          => @account_number,
          :"AccountSource"                          => @account_source,
          :"Acres__c"                               => @acres__c,
          :"AnnualRevenue"                          => @annual_revenue,
          :"Appraised_Value__c"                     => @appraised_value__c,
          :"Approximate_Value__c"                   => @approximate_value__c,
          :"Bankruptcy_Date__c"                     => @bankruptcy_date__c,
          :"Bathrooms__c"                           => @bathrooms__c,
          :"Bedrooms__c"                            => @bedrooms__c,
          :"BillingCity"                            => @billingcity,
          :"BillingPostalCode"                      => @billingpostalcode,
          :"BillingState"                           => @billingstate,
          :"BillingStreet"                          => @billingstreet,
          :"Broker_Commission__c"                   => @broker_commission__c,
          :"Buyer_Agency_Date__c"                   => @buyer_agency_date__c,
          :"Buyer_to_Contract__c"                   => @buyer_to_contract__c,
          :"CAP__c"                                 => @cap__c,
          :"CCD_Closed_Date__c"                     => @ccd_closed_date__c,
          :"CCD_Closed_Lost_Reason__c"              => @ccd_closed_lost_reason__c,
          :"CCD_Closing_Status__c"                  => @ccd_closing_status__c,
          :"CNDForCredit__c"                        => @cndforcredit__c,
          :"CND_Date_Stamp__c"                      => @cnd_date_stamp__c,
          :"CSR__c"                                 => @csr__c,
          :"Call_Status__c"                         => @call_status__c,
          :"Client_Docs__c"                         => @client_docs__c,
          :"Close_Date_w_AHA__c"                    => @close_date_w_aha__c,
          :"ClosedGrossCommission__c"               => @closedgrosscommission__c,
          :"Closed_Docs__c"                         => @closed_docs__c,
          :"Closed_Purchase_Val__c"                 => @closed_purchase_val__c,
          :"Closed_With_AHA__c"                     => @closed_with_aha__c,
          :"Commission_to_Broker__c"                => @commission_to_broker__c,
          :"Condo_Type__c"                          => @condo_type__c,
          :"Contract_to_Close__c"                   => @contract_to_close__c,
          :"CreatedBy"                              => @created_by,
          :"Credit_Agent__c"                        => @credit_agent__c,
          :"Credit_Care_Status__c"                  => @credit_care_status__c,
          :"Credit_Repair_Referral__c"              => @credit_repair_referral__c,
          :"Current_Rent__c"                        => @current_rent__c,
          :"DM_Call__c"                             => @dm_call__c,
          :"DNG_Reason__c"                          => @dng_reason__c,
          :"Days_Old__c"                            => @days_old__c,
          :"Description"                            => @description,
          :"Down_Payment_Notes__c"                  => @down_payment_notes__c,
          :"Down_Payment__c"                        => @down_payment__c,
          :"Endorser__c"                            => @endorser__c,
          :"Escrowed__c"                            => @escrowed__c,
          :"Est_Close_Date_w_AHA__c"                => @est_close_date_w_aha__c,
          :"Estimated_Date_to_Complete_CAP__c"      => @estimated_date_to_complete_cap__c,
          :"Estimated_Time_to_Complete_Program__c"  => @estimated_time_to_complete_program__c,
          :"Fax"                                    => @fax,
          :"FileDataID__c"                          => @filedataid__c,
          :"Flat_Fee__c"                            => @flat_fee__c,
          :"Foreclosure_Date__c"                    => @foreclosure_date__c,
          :"Former_Bankruptcy__c"                   => @former_bankruptcy__c,
          :"Former_Foreclosure__c"                  => @former_foreclosure__c,
          :"Gross_Commission_All__c"                => @gross_commission_all__c,
          :"Gross_Commission__c"                    => @gross_commission__c,
          :"HOA_Dues__c"                            => @hoa_dues__c,
          :"If_VA_Eligible_have_they_used_it__c"    => @if_va_eligible_have_they_used_it__c,
          :"Industry"                               => @industry,
          :"Inside_Realtor__c"                      => @inside_realtor__c,
          :"Inspection_Objection_Date__c"           => @inspection_objection_date__c,
          :"Internet_Lead__c"                       => @internet_lead__c,
          :"Internet_Source__c"                     => @internet_source__c,
          :"IsCustomerPortal"                       => @is_customer_portal,
          :"Jigsaw"                                 => @jigsaw,
          :"LOS_Issues__c"                          => @los_issues__c,
          :"LastModifiedBy"                         => @last_modified_by,
          :"Last_Appraisal__c"                      => @last_appraisal__c,
          :"Last_Date_Listed__c"                    => @last_date_listed__c,
          :"Last_Price_Listed_For__c"               => @last_price_listed_for__c,
          :"Lead_Sent_to_SqlByte__c"                => @lead_sent_to_sqlbyte__c,
          :"Lead_Type__c"                           => @lead_type__c,
          :"Listing_Agent_Broker__c"                => @listing_agent_broker__c,
          :"Listing_Agent_Cell_Phone__c"            => @listing_agent_cell_phone__c,
          :"Listing_Agent_Company__c"               => @listing_agent_company__c,
          :"Listing_Agent_Email__c"                 => @listing_agent_email__c,
          :"Listing_Agent_Work_Phone__c"            => @listing_agent_work_phone__c,
          :"Listing_Contract_Date__c"               => @listing_contract_date__c,
          :"Loan_Commitment_Date__c"                => @loan_commitment_date__c,
          :"Loan_Purpose__c"                        => @loan_purpose__c,
          :"Loan_Type__c"                           => @loan_type__c,
          :"Median_Score__c"                        => @median_score__c,
          :"Monthly_Budget__c"                      => @monthly_budget__c,
          :"Monthly_Insurance__c"                   => @monthly_insurance__c,
          :"Monthly_Taxes__c"                       => @monthly_taxes__c,
          :"Mortgage_Notes__c"                      => @mortgage_notes__c,
          :"Name"                                   => @name,
          :"New_File_To_Buyer__c"                   => @new_file_to_buyer__c,
          :"New_Purchase_Price__c"                  => @new_purchase_price__c,
          :"Not_A_Lead__c"                          => @not_a_lead__c,
          :"NumberOfEmployees"                      => @numberofemployees,
          :"Number_of_Units__c"                     => @number_of_units__c,
          :"Occupancy_Type__c"                      => @occupancy_type__c,
          :"Original_Endorser__c"                   => @original_endorser__c,
          :"Original_Purchase_Price__c"             => @original_purchase_price__c,
          :"Original_Source__c"                     => @original_source__c,
          :"Outside_Financing__c"                   => @outside_financing__c,
          :"Outside_Real_Estate_Company__c"         => @outside_real_estate_company__c,
          :"Owner"                                  => @owner,
          :"OwnerCell__c"                           => @ownercell__c,
          :"Owner_from_Original_Lead__c"            => @owner_from_original_lead__c,
          :"Ownership"                              => @ownership,
          :"Parent"                                 => @parent,
          :"Pending_Docs__c"                        => @pending_docs__c,
          :"Phone"                                  => @phone,
          :"Previous_Year_30_Day_Mortgage_Lates__c" => @previous_year_30_day_mortgage_lates__c,
          :"Price_Range__c"                         => @price_range__c,
          :"Primary_Borrower_Email__c"              => @primary_borrower_email__c,
          :"Primary_Borrower_Name__c"               => @primary_borrower_name__c,
          :"Primary_Borrower_Phone__c"              => @primary_borrower_phone__c,
          :"Processor__c"                           => @processor__c,
          :"Program_Coordinator__c"                 => @program_coordinator__c,
          :"Property_Type__c"                       => @property_type__c,
          :"Puchase_Close_Date__c"                  => @puchase_close_date__c,
          :"Purchase_Contract_Date__c"              => @purchase_contract_date__c,
          :"Purchase_Date__c"                       => @purchase_date__c,
          :"Rating"                                 => @rating,
          :"Realtor_Email__c"                       => @realtor_email__c,
          :"Realtor_Name__c"                        => @realtor_name__c,
          :"Realtor_Phone_Number__c"                => @realtor_phone_number__c,
          :"Referral_Commission__c"                 => @referral_commission__c,
          :"Refinance_Purpose__c"                   => @refinance_purpose__c,
          :"Related_File__c"                        => @related_file__c,
          :"Renting_Current_Home__c"                => @renting_current_home__c,
          :"Rescore_Date__c"                        => @rescore_date__c,
          :"Rescore_Done__c"                        => @rescore_done__c,
          :"Residence_Type__c"                      => @residence_type__c,
          :"Scanning_Complete__c"                   => @scanning_complete__c,
          :"Score_Update__c"                        => @score_update__c,
          :"SearchAdgroup__c"                       => @searchadgroup__c,
          :"SearchCampaign__c"                      => @searchcampaign__c,
          :"SearchKeyword__c"                       => @searchkeyword__c,
          :"SearchSource__c"                        => @searchsource__c,
          :"Selling_Current_Home__c"                => @selling_current_home__c,
          :"Session_UUID__c"                        => @session_uuid__c,
          :"ShippingAddress"                        => @shipping_address,
          :"Sic"                                    => @sic,
          :"SicDesc"                                => @sic_description,
          :"Sign_Off_Location__c"                   => @sign_off_location__c,
          :"Sign_Up_Date__c"                        => @sign_up_date__c,
          :"Site"                                   => @site,
          :"Source__c"                              => @source__c,
          :"Square_Feet__c"                         => @square_feet__c,
          :"Subject_Property_Address__c"            => @subject_property_address__c,
          :"Subject_Property_City__c"               => @subject_property_city__c,
          :"Subject_Property_State__c"              => @subject_property_state__c,
          :"Subject_Property_Zip__c"                => @subject_property_zip__c,
          :"TickerSymbol"                           => @ticker_symbol,
          :"Title_Address__c"                       => @title_address__c,
          :"Title_Closer_Name__c"                   => @title_closer_name__c,
          :"Title_Company_Name__c"                  => @title_company_name__c,
          :"Title_Email__c"                         => @title_email__c,
          :"Title_Fax__c"                           => @title_fax__c,
          :"Title_Phone__c"                         => @title_phone__c,
          :"Title_State__c"                         => @title_state__c,
          :"Title_Zip__c"                           => @title_zip__c,
          :"Type"                                   => @type,
          :"Type__c"                                => @type__c,
          :"VA_Eligible__c"                         => @va_eligible__c,
          :"Velo_Last_Action_Date__c"               => @velo_last_action_date__c,
          :"Velo__Is_Synced_with_Velocify__c"       => @velo__is_synced_with_velocify__c,
          :"Velo__Lead360RecordId__c"               => @velo__lead360recordid__c,
          :"Velo__Leads360_MileStoneId__c"          => @velo__leads360_milestoneid__c,
          :"Velo__Record_History__c"                => @velo__record_history__c,
          :"Velo__Salesforce_Owner_Name__c"         => @velo__salesforce_owner_name__c,
          :"Velo__Salesforce_Owner_ProfileName__c"  => @velo__salesforce_owner_profilename__c,
          :"Velo__Salesforce_Owner_Role_Name__c"    => @velo__salesforce_owner_role_name__c,
          :"Velo__Time_Zone__c"                     => @velo__time_zone__c,
          :"Velocify_Owner__c"                      => @velocify_owner__c,
          :"Website"                                => @website,
          :"WhenSelling__c"                         => @whenselling__c,
          :"Working_with_Realtor__c"                => @working_with_realtor__c,
          :"X1_Referral_Date__c"                    => @x1_referral_date__c,
          :"X1_Referral_Name__c"                    => @x1_referral_name__c,
          :"X1_Referral_Phone__c"                   => @x1_referral_phone__c,
          :"X1st_Mortgage_Balance__c"               => @x1st_mortgage_balance__c,
          :"X1st_Mortgage_Payment__c"               => @x1st_mortgage_payment__c,
          :"X1st_Mortgage_Rate__c"                  => @x1st_mortgage_rate__c,
          :"X2_Referral_Date__c"                    => @x2_referral_date__c,
          :"X2_Referral_Name__c"                    => @x2_referral_name__c,
          :"X2_Referral_Phone__c"                   => @x2_referral_phone__c,
          :"X2nd_Mortgage_Balance__c"               => @x2nd_mortgage_balance__c,
          :"X2nd_Mortgage_Date_Opened__c"           => @x2nd_mortgage_date_opened__c,
          :"X2nd_Mortgage_Payment__c"               => @x2nd_mortgage_payment__c,
          :"X2nd_Mortgage_Rate__c"                  => @x2nd_mortgage_rate__c,
          :"X2nd_Mortgage__c"                       => @x2nd_mortgage__c,
          :"X3_Referral_Date__c"                    => @x3_referral_date__c,
          :"X3_Referral_Name__c"                    => @x3_referral_name__c,
          :"X3_Referral_Phone__c"                   => @x3_referral_phone__c,
          :"X4_Referral_Date__c"                    => @x4_referral_date__c,
          :"X4_Referral_Name__c"                    => @x4_referral_name__c,
          :"X4_Referral_Phone__c"                   => @x4_referral_phone__c
        }.select{ |k,v| !v.nil? }

        AFCSalesforce::DataTruncator.truncate_hash(salesforce_hash)
      end
    end
  end
end
