module AFCSalesforce
  module Models
    class AHCRealtor < AFCSalesforce::Models::Base
      attr_accessor :name, :createdby, :lastmodifiedby, :owner,
                    :afc_preferred_partner__c, :agent_disposition__c, :agent_first__c, :agent_last__c,
                    :agent_referred__c, :approved__c, :broker__c, :cell_phone__c, :city__c,
                    :client_tiers__c, :company__c, :designations__c, :email__c, :good_standing__c,
                    :how_better_process__c, :how_improve_process__c, :license_number__c,
                    :likely_recommend_afc__c, :main_company__c, :managing_broker__c, :nar_member__c, :notes__c,
                    :owner__c, :rate_afc_process__c, :rate_mc__c, :rate_purchase_process__c, :rate_speed_ease__c,
                    :service_areas__c, :state_code__c, :street__c, :what_change_if_went_back_in_time__c, :years_in_business__c

      set_as_integer :active_financing_partners__c, :closed_last_12_months__c, :number_of_agents__c, :transaction_sides_ltm__c,
                     :volume_ltm__c, :zip__c

      set_as_boolean :agent_referred__c, :broker__c, :good_standing__c, :managing_broker__c, :nar_member__c,
                     :owner__c, :afc_preferred_partner__c,

      def to_h
        {
          :"Name"                                => @name,
          :"CreatedBy"                           => @createdby,
          :"LastModifiedBy"                      => @lastmodifiedby,
          :"Owner"                               => @owner,
          :"Active_Financing_Partners__c"        => @active_financing_partners__c,
          :"AFC_Preferred_Partner__c"            => @afc_preferred_partner__c,
          :"Agent_Disposition__c"                => @agent_disposition__c,
          :"Agent_First__c"                      => @agent_first__c,
          :"Agent_Last__c"                       => @agent_last__c,
          :"Agent_Referred__c"                   => @agent_referred__c,
          :"Approved__c"                         => @approved__c,
          :"Broker__c"                           => @broker__c,
          :"Cell_Phone__c"                       => @cell_phone__c,
          :"City__c"                             => @city__c,
          :"Client_Tiers__c"                     => @client_tiers__c,
          :"Closed_Last_12_Months__c"            => @closed_last_12_months__c,
          :"Company__c"                          => @company__c,
          :"Designations__c"                     => @designations__c,
          :"Email__c"                            => @email__c,
          :"Good_Standing__c"                    => @good_standing__c,
          :"How_Better_Process__c"               => @how_better_process__c,
          :"How_improve_process__c"              => @how_improve_process__c,
          :"License_Number__c"                   => @license_number__c,
          :"Likely_Recommend_AFC__c"             => @likely_recommend_afc__c,
          :"Main_Company__c"                     => @main_company__c,
          :"Managing_Broker__c"                  => @managing_broker__c,
          :"NAR_Member__c"                       => @nar_member__c,
          :"Notes__c"                            => @notes__c,
          :"Number_of_Agents__c"                 => @number_of_agents__c,
          :"Owner__c"                            => @owner__c,
          :"Rate_AFC_Process__c"                 => @rate_afc_process__c,
          :"Rate_MC__c"                          => @rate_mc__c,
          :"Rate_Purchase_Process__c"            => @rate_purchase_process__c,
          :"Rate_Speed_Ease__c"                  => @rate_speed_ease__c,
          :"Service_Areas__c"                    => @service_areas__c,
          :"State_Code__c"                       => @state_code__c,
          :"Street__c"                           => @street__c,
          :"Transaction_Sides_LTM__c"            => @transaction_sides_ltm__c,
          :"Volume_LTM__c"                       => @volume_ltm__c,
          :"What_change_if_went_back_in_time__c" => @what_change_if_went_back_in_time__c,
          :"Years_In_Business__c"                => @years_in_business__c,
          :"Zip__c"                              => @zip__c
        }.select{ |k,v| !v.nil? }
      end
    end
  end
end