module AFCSalesforce
  module Models
    class Asset < AFCSalesforce::Models::Base
      attr_accessor :name, :createdby, :lastmodifiedby, :owner, :assetid__c, :asset_type__c,
                    :asset_value__c, :belongs_to__c, :contact__c, :account__c, :filedataid__c

      set_as_float :asset_value__c

      def to_h
        {
          :"Name"           => @name,
          :"CreatedBy"      => @createdby,
          :"LastModifiedBy" => @lastmodifiedby,
          :"Owner"          => @owner,
          :"AssetID__c"     => @assetid__c,
          :"Asset_Type__c"  => @asset_type__c,
          :"Asset_Value__c" => @asset_value__c,
          :"Belongs_To__c"  => @belongs_to__c,
          :"Contact__c"     => @contact__c,
          :"Account__c"     => @account__c,
          :"FileDataID__c"  => @filedataid__c
        }.select{ |k,v| !v.nil? }
      end
    end
  end
end









