module AFCSalesforce
  module Models
    class Contact < AFCSalesforce::Models::Base
      attr_accessor :account,
                    :actual_mailing_city__c,
                    :actual_mailing_state__c,
                    :actual_mailing_street__c,
                    :actual_mailing_zip__c,
                    :additional_income_type__c,
                    :amount__c,
                    :assistantname,
                    :assistantphone,
                    :birthdate,
                    :bor_company_name__c,
                    :bor_efx__c,
                    :bor_exp__c,
                    :bor_tu__c,
                    :borrower_type__c,
                    :borrowerid__c,
                    :cobor_efx__c,
                    :cobor_exp__c,
                    :cobor_tu__c,
                    :coborrowerid__c,
                    :createdby,
                    :current_employer_phone__c,
                    :department,
                    :description,
                    :donotcall,
                    :email,
                    :employer_phone__c,
                    :fax,
                    :filedataid__c,
                    :hasoptedoutofemail,
                    :hasoptedoutoffax,
                    :homephone,
                    :is_self_employed__c,
                    :jigsaw,
                    :lastcurequestdate,
                    :lastcuupdatedate,
                    :lastmodifiedby,
                    :lastname,
                    :leadsource,
                    :mailingstreet,
                    :marital_status__c,
                    :middle_name__c,
                    :mobilephone,
                    :monthly_income__c,
                    :firstname,
                    :otheraddress,
                    :otherphone,
                    :owner,
                    :phone,
                    :primary_borrower__c,
                    :reportsto,
                    :sms_opt_in__c,
                    :ssn__c,
                    :suffix__c,
                    :title,
                    :va_dependent_ages__c,
                    :va_dependent_count__c,
                    :velo__apex_context__c,
                    :velo__email_domain__c,
                    :velo__is_synced_with_velocify__c,
                    :velo__lead360recordid__c,
                    :velo__leads360_milestoneid__c,
                    :velo__record_history__c,
                    :velo__salesforce_owner_name__c,
                    :velo__salesforce_owner_profilename__c,
                    :velo__salesforce_owner_role_name__c,
                    :velo__status__c,
                    :velo__time_zone__c,
                    :work_phone__c,
                    :x1_prev_emp_from__c,
                    :x1_prev_emp_name__c,
                    :x1_prev_emp_monthly_income__c,
                    :x2_prev_emp_monthly_income__c,
                    :x1_prev_emp_phone__c,
                    :x1_prev_emp_position__c,
                    :x1_prev_emp_to__c,
                    :x1_previous_employer_notes__c,
                    :x1_residence_city__c,
                    :x1_residence_months__c,
                    :x1_residence_notes__c,
                    :x1_residence_state__c,
                    :x1_residence_status__c,
                    :x1_residence_street__c,
                    :x1_residence_years__c,
                    :x1_residence_zip__c,
                    :x2_prev_emp_from__c,
                    :x2_prev_emp_name__c,
                    :x2_prev_emp_phone__c,
                    :x2_prev_emp_position__c,
                    :x2_prev_emp_to__c,
                    :x2_previous_employer_notes__c,
                    :x2_residence_city__c,
                    :x2_residence_months__c,
                    :x2_residence_notes__c,
                    :x2_residence_state__c,
                    :x2_residence_status__c,
                    :x2_residence_street__c,
                    :x2_residence_years__c,
                    :x2_residence_zip__c,
                    :x3_prev_emp_from__c,
                    :x3_prev_emp_name__c,
                    :x3_prev_emp_phone__c,
                    :x3_prev_emp_position__c,
                    :x3_prev_emp_to__c,
                    :x3_previous_employer_notes__c,
                    :x3_residence_city__c,
                    :x3_residence_months__c,
                    :x3_residence_notes__c,
                    :x3_residence_state__c,
                    :x3_residence_status__c,
                    :x3_residence_street__c,
                    :x3_residence_years__c,
                    :x3_residence_zip__c,
                    :yearly_income__c,
                    :years_on_the_job__c,
                    :mailingcity,
                    :mailingstate,
                    :mailingpostalcode,
                    :session_uuid__c

      set_as_float :amount__c,
                   :monthly_income__c,
                   :x1_prev_emp_monthly_income__c,
                   :x2_prev_emp_monthly_income__c,
                   :yearly_income__c

      set_as_integer :x1_residence_months__c,
                     :x1_residence_years__c,
                     :x2_residence_months__c,
                     :x2_residence_years__c,
                     :x3_residence_months__c,
                     :x3_residence_years__c,
                     :velo__leads360_milestoneid__c,
                     :years_on_the_job__c

      set_as_date :x1_prev_emp_from__c,
                  :x1_prev_emp_to__c,
                  :x2_prev_emp_from__c,
                  :x2_prev_emp_to__c,
                  :x3_prev_emp_from__c,
                  :x3_prev_emp_to__c

      def to_h
        salesforce_hash = {
          :"Account"                               => @account,
          :"Actual_Mailing_City__c"                => @actual_mailing_city__c,
          :"Actual_Mailing_State__c"               => @actual_mailing_state__c,
          :"Actual_Mailing_Street__c"              => @actual_mailing_street__c,
          :"Actual_Mailing_Zip__c"                 => @actual_mailing_zip__c,
          :"Additional_Income_Type__c"             => @additional_income_type__c,
          :"Amount__c"                             => @amount__c,
          :"AssistantName"                         => @assistantname,
          :"AssistantPhone"                        => @assistantphone,
          :"Birthdate"                             => @birthdate,
          :"Bor_Company_Name__c"                   => @bor_company_name__c,
          :"Bor_Efx__c"                            => @bor_efx__c,
          :"Bor_Exp__c"                            => @bor_exp__c,
          :"Bor_TU__c"                             => @bor_tu__c,
          :"Borrower_Type__c"                      => @borrower_type__c,
          :"BorrowerID__c"                         => @borrowerid__c,
          :"CoBor_Efx__c"                          => @cobor_efx__c,
          :"CoBor_Exp__c"                          => @cobor_exp__c,
          :"CoBor_TU__c"                           => @cobor_tu__c,
          :"CoBorrowerID__c"                       => @coborrowerid__c,
          :"CreatedBy"                             => @createdby,
          :"Current_Employer_Phone__c"             => @current_employer_phone__c,
          :"Department"                            => @department,
          :"Description"                           => @description,
          :"DoNotCall"                             => @donotcall,
          :"Email"                                 => @email,
          :"Employer_Phone__c"                     => @employer_phone__c,
          :"Fax"                                   => @fax,
          :"FileDataID__c"                         => @filedataid__c,
          :"HasOptedOutOfEmail"                    => @hasoptedoutofemail,
          :"HasOptedOutOfFax"                      => @hasoptedoutoffax,
          :"HomePhone"                             => @homephone,
          :"Is_Self_Employed__c"                   => @is_self_employed__c,
          :"Jigsaw"                                => @jigsaw,
          :"LastCURequestDate"                     => @lastcurequestdate,
          :"LastCUUpdateDate"                      => @lastcuupdatedate,
          :"LastModifiedBy"                        => @lastmodifiedby,
          :"LeadSource"                            => @leadsource,
          :"MailingStreet"                         => @mailingstreet,
          :"MailingCity"                           => @mailingcity,
          :"MailingState"                          => @mailingstate,
          :"MailingPostalCode"                     => @mailingpostalcode,
          :"Marital_Status__c"                     => @marital_status__c,
          :"Middle_Name__c"                        => @middle_name__c,
          :"MobilePhone"                           => @mobilephone,
          :"Monthly_Income__c"                     => @monthly_income__c,
          :"FirstName"                             => @firstname,
          :"LastName"                              => @lastname,
          :"OtherAddress"                          => @otheraddress,
          :"OtherPhone"                            => @otherphone,
          :"Owner"                                 => @owner,
          :"Phone"                                 => @phone,
          :"Primary_Borrower__c"                   => @primary_borrower__c,
          :"ReportsTo"                             => @reportsto,
          :"SMS_Opt_In__c"                         => @sms_opt_in__c,
          :"SSN__c"                                => @ssn__c,
          :"Suffix__c"                             => @suffix__c,
          :"Title"                                 => @title,
          :"VA_Dependent_Ages__c"                  => @va_dependent_ages__c,
          :"VA_Dependent_Count__c"                 => @va_dependent_count__c,
          :"Velo__Apex_Context__c"                 => @velo__apex_context__c,
          :"Velo__Email_Domain__c"                 => @velo__email_domain__c,
          :"Velo__Is_Synced_with_Velocify__c"      => @velo__is_synced_with_velocify__c,
          :"Velo__Lead360RecordId__c"              => @velo__lead360recordid__c,
          :"Velo__Leads360_MileStoneId__c"         => @velo__leads360_milestoneid__c,
          :"Velo__Record_History__c"               => @velo__record_history__c,
          :"Velo__Salesforce_Owner_Name__c"        => @velo__salesforce_owner_name__c,
          :"Velo__Salesforce_Owner_ProfileName__c" => @velo__salesforce_owner_profilename__c,
          :"Velo__Salesforce_Owner_Role_Name__c"   => @velo__salesforce_owner_role_name__c,
          :"Velo__Status__c"                       => @velo__status__c,
          :"Velo__Time_Zone__c"                    => @velo__time_zone__c,
          :"Work_Phone__c"                         => @work_phone__c,
          :"X1_Prev_Emp_From__c"                   => @x1_prev_emp_from__c,
          :"X1_Prev_Emp_Name__c"                   => @x1_prev_emp_name__c,
          :"X1_Prev_Emp_Monthly_Income__c"         => @x1_prev_emp_monthly_income__c,
          :"X2_Prev_Emp_Monthly_Income__c"         => @x2_prev_emp_monthly_income__c,
          :"X1_Prev_Emp_Phone__c"                  => @x1_prev_emp_phone__c,
          :"X1_Prev_Emp_Position__c"               => @x1_prev_emp_position__c,
          :"X1_Prev_Emp_To__c"                     => @x1_prev_emp_to__c,
          :"X1_Previous_Employer_Notes__c"         => @x1_previous_employer_notes__c,
          :"X1_Residence_City__c"                  => @x1_residence_city__c,
          :"X1_Residence_Months__c"                => @x1_residence_months__c,
          :"X1_Residence_Notes__c"                 => @x1_residence_notes__c,
          :"X1_Residence_State__c"                 => @x1_residence_state__c,
          :"X1_Residence_Status__c"                => @x1_residence_status__c,
          :"X1_Residence_Street__c"                => @x1_residence_street__c,
          :"X1_Residence_Years__c"                 => @x1_residence_years__c,
          :"X1_Residence_Zip__c"                   => @x1_residence_zip__c,
          :"X2_Prev_Emp_From__c"                   => @x2_prev_emp_from__c,
          :"X2_Prev_Emp_Name__c"                   => @x2_prev_emp_name__c,
          :"X2_Prev_Emp_Phone__c"                  => @x2_prev_emp_phone__c,
          :"X2_Prev_Emp_Position__c"               => @x2_prev_emp_position__c,
          :"X2_Prev_Emp_To__c"                     => @x2_prev_emp_to__c,
          :"X2_Previous_Employer_Notes__c"         => @x2_previous_employer_notes__c,
          :"X2_Residence_City__c"                  => @x2_residence_city__c,
          :"X2_Residence_Months__c"                => @x2_residence_months__c,
          :"X2_Residence_Notes__c"                 => @x2_residence_notes__c,
          :"X2_Residence_State__c"                 => @x2_residence_state__c,
          :"X2_Residence_Status__c"                => @x2_residence_status__c,
          :"X2_Residence_Street__c"                => @x2_residence_street__c,
          :"X2_Residence_Years__c"                 => @x2_residence_years__c,
          :"X2_Residence_Zip__c"                   => @x2_residence_zip__c,
          :"X3_Prev_Emp_From__c"                   => @x3_prev_emp_from__c,
          :"X3_Prev_Emp_Name__c"                   => @x3_prev_emp_name__c,
          :"X3_Prev_Emp_Phone__c"                  => @x3_prev_emp_phone__c,
          :"X3_Prev_Emp_Position__c"               => @x3_prev_emp_position__c,
          :"X3_Prev_Emp_To__c"                     => @x3_prev_emp_to__c,
          :"X3_Previous_Employer_Notes__c"         => @x3_previous_employer_notes__c,
          :"X3_Residence_City__c"                  => @x3_residence_city__c,
          :"X3_Residence_Months__c"                => @x3_residence_months__c,
          :"X3_Residence_Notes__c"                 => @x3_residence_notes__c,
          :"X3_Residence_State__c"                 => @x3_residence_state__c,
          :"X3_Residence_Status__c"                => @x3_residence_status__c,
          :"X3_Residence_Street__c"                => @x3_residence_street__c,
          :"X3_Residence_Years__c"                 => @x3_residence_years__c,
          :"X3_Residence_Zip__c"                   => @x3_residence_zip__c,
          :"Yearly_Income__c"                      => @yearly_income__c,
          :"Years_on_the_Job__c"                   => @years_on_the_job__c,
          :"Session_UUID__c"                       => @session_uuid__c
        }.select{ |k,v| !v.nil? }

        AFCSalesforce::DataTruncator.truncate_hash(salesforce_hash)
      end
    end
  end
end
