 module AFCSalesforce
  module Models
    class Income < AFCSalesforce::Models::Base
      attr_accessor :createdby, :lastmodifiedby, :name, :owner, :amount__c, :borrower__c,
                    :description__c, :is_self_employed__c, :otherincomeid__c, :type__c

      set_as_float :amount__c

      def to_h
        {
          :"CreatedBy"           => @createdby,
          :"LastModifiedBy"      => @lastmodifiedby,
          :"Name"                => @name,
          :"Owner"               => @owner,
          :"Amount__c"           => @amount__c,
          :"Borrower__c"         => @borrower__c,
          :"Description__c"      => @description__c,
          :"Is_Self_Employed__c" => @is_self_employed__c,
          :"OtherIncomeID__c"    => @otherincomeid__c,
          :"Type__c"             => @type__c
        }.select{ |k,v| !v.nil? }
      end
    end
  end
end