module AFCSalesforce
  module Models
    class Lead < AFCSalesforce::Models::Base
      attr_accessor :address,
                    :aha_lead__c,
                    :annualrevenue,
                    :campaign,
                    :city,
                    :company,
                    :createdby,
                    :csr__c,
                    :csrname__c,
                    :description,
                    :donotcall,
                    :email,
                    :endorser__c,
                    :fax,
                    :filedataid__c,
                    :firstname,
                    :hasoptedoutofemail,
                    :hasoptedoutoffax,
                    :industry,
                    :inside_realtor__c,
                    :internet_lead__c,
                    :internetsource__c,
                    :jigsaw,
                    :lastmodifiedby,
                    :lastname,
                    :lasttransferdate,
                    :lead_status__c,
                    :leadborrowerid__c,
                    :leadsource,
                    :mobilephone,
                    :numberofemployees,
                    :original_date_created__c,
                    :original_endorser__c,
                    :original_source__c,
                    :outside_company__c,
                    :outside_financing__c,
                    :owner,
                    :ownername__c,
                    :page_url__c,
                    :page_variant__c,
                    :phone,
                    :postalcode,
                    :rating,
                    :realtor_name__c,
                    :redirect_url__c,
                    :residence_type__c,
                    :searchadgroup__c,
                    :searchcampaign__c,
                    :searchkeyword__c,
                    :searchsource__c,
                    :sent_to_sqlbyte__c,
                    :session_uuid__c,
                    :set_account_owner_on_convert__c,
                    :set_opportunity_name_on_convert__c,
                    :set_opportunity_owner_on_convert__c,
                    :set_primary_borrower_email_on_convert__c,
                    :set_primary_borrower_name_on_convert__c,
                    :set_primary_borrower_phone_on_convert__c,
                    :set_primary_lead_on_convert__c,
                    :set_state_name_onconvert__c,
                    :set_zip_onconvert__c,
                    :source__c,
                    :state,
                    :status,
                    :submitterip__c,
                    :title,
                    :type__c,
                    :unbounce_page_id__c,
                    :unbouncesubmissiondate__c,
                    :unbouncesubmissiontime__c,
                    :velo__apex_context__c,
                    :velo__email_domain__c,
                    :velo__is_synced_with_velocify__c,
                    :velo__lead360recordid__c,
                    :velo__leads360_milestoneid__c,
                    :velo__record_history__c,
                    :velo__salesforce_owner_name__c,
                    :velo__salesforce_owner_profilename__c,
                    :velo__salesforce_owner_role_name__c,
                    :velo__time_zone__c,
                    :velo__transfer_history_to__c,
                    :velo__velocify_lead_import_external_id__c,
                    :velocify_action__c,
                    :velocify_owner__c,
                    :website,
                    :whenselling__c,
                    :working_with_realtor__c

      set_as_integer :annualrevenue,
                     :numberofemployees,
                     :velo__leads360_milestoneid__c

      set_as_date :lasttransferdate,
                  :original_date_created__c,
                  :unbouncesubmissiondate__c

      def to_h
        salesforce_hash = {
          :"AHA_Lead__c"                               => @aha_lead__c,
          :"Address"                                   => @address,
          :"AnnualRevenue"                             => @annualrevenue,
          :"CSRName__c"                                => @csrname__c,
          :"CSR__c"                                    => @csr__c,
          :"Campaign"                                  => @campaign,
          :"City"                                      => @city,
          :"Company"                                   => @company,
          :"CreatedBy"                                 => @createdby,
          :"Description"                               => @description,
          :"DoNotCall"                                 => @donotcall,
          :"Email"                                     => @email,
          :"Endorser__c"                               => @endorser__c,
          :"Fax"                                       => @fax,
          :"FileDataID__c"                             => @filedataid__c,
          :"FirstName"                                 => @firstname,
          :"HasOptedOutOfEmail"                        => @hasoptedoutofemail,
          :"HasOptedOutOfFax"                          => @hasoptedoutoffax,
          :"Industry"                                  => @industry,
          :"Inside_Realtor__c"                         => @inside_realtor__c,
          :"InternetSource__c"                         => @internetsource__c,
          :"Internet_Lead__c"                          => @internet_lead__c,
          :"Jigsaw"                                    => @jigsaw,
          :"LastModifiedBy"                            => @lastmodifiedby,
          :"LastName"                                  => @lastname,
          :"LastTransferDate"                          => @lasttransferdate,
          :"LeadBorrowerId__c"                         => @leadborrowerid__c,
          :"LeadSource"                                => @leadsource,
          :"Lead_Status__c"                            => @lead_status__c,
          :"MobilePhone"                               => @mobilephone,
          :"NumberOfEmployees"                         => @numberofemployees,
          :"Original_Date_Created__c"                  => @original_date_created__c,
          :"Original_Endorser__c"                      => @original_endorser__c,
          :"Original_Source__c"                        => @original_source__c,
          :"Outside_Company__c"                        => @outside_company__c,
          :"Outside_Financing__c"                      => @outside_financing__c,
          :"Owner"                                     => @owner,
          :"OwnerName__c"                              => @ownername__c,
          :"Page_Url__c"                               => @page_url__c,
          :"Page_Variant__c"                           => @page_variant__c,
          :"Phone"                                     => @phone,
          :"PostalCode"                                => @postalcode,
          :"Rating"                                    => @rating,
          :"Realtor_Name__c"                           => @realtor_name__c,
          :"Redirect_URL__c"                           => @redirect_url__c,
          :"Residence_Type__c"                         => @residence_type__c,
          :"SearchAdgroup__c"                          => @searchadgroup__c,
          :"SearchCampaign__c"                         => @searchcampaign__c,
          :"SearchKeyword__c"                          => @searchkeyword__c,
          :"SearchSource__c"                           => @searchsource__c,
          :"Sent_to_SqlByte__c"                        => @sent_to_sqlbyte__c,
          :"Set_Account_Owner_on_Convert__c"           => @set_account_owner_on_convert__c,
          :"Set_Opportunity_Name_on_Convert__c"        => @set_opportunity_name_on_convert__c,
          :"Set_Opportunity_Owner_on_Convert__c"       => @set_opportunity_owner_on_convert__c,
          :"Set_Primary_Borrower_Email_On_Convert__c"  => @set_primary_borrower_email_on_convert__c,
          :"Set_Primary_Borrower_Name_on_Convert__c"   => @set_primary_borrower_name_on_convert__c,
          :"Set_Primary_Borrower_Phone_on_Convert__c"  => @set_primary_borrower_phone_on_convert__c,
          :"Set_Primary_Lead_on_Convert__c"            => @set_primary_lead_on_convert__c,
          :"Set_State_Name_OnConvert__c"               => @set_state_name_onconvert__c,
          :"Set_Zip_OnConvert__c"                      => @set_zip_onconvert__c,
          :"Source__c"                                 => @source__c,
          :"State"                                     => @state,
          :"Status"                                    => @status,
          :"SubmitterIP__c"                            => @submitterip__c,
          :"Title"                                     => @title,
          :"Type__c"                                   => @type__c,
          :"UnbounceSubmissionDate__c"                 => @unbouncesubmissiondate__c,
          :"UnbounceSubmissionTime__c"                 => @unbouncesubmissiontime__c,
          :"Unbounce_Page_ID__c"                       => @unbounce_page_id__c,
          :"Velo__Apex_Context__c"                     => @velo__apex_context__c,
          :"Velo__Email_Domain__c"                     => @velo__email_domain__c,
          :"Velo__Is_Synced_with_Velocify__c"          => @velo__is_synced_with_velocify__c,
          :"Velo__Lead360RecordId__c"                  => @velo__lead360recordid__c,
          :"Velo__Leads360_MileStoneId__c"             => @velo__leads360_milestoneid__c,
          :"Velo__Record_History__c"                   => @velo__record_history__c,
          :"Velo__Salesforce_Owner_Name__c"            => @velo__salesforce_owner_name__c,
          :"Velo__Salesforce_Owner_ProfileName__c"     => @velo__salesforce_owner_profilename__c,
          :"Velo__Salesforce_Owner_Role_Name__c"       => @velo__salesforce_owner_role_name__c,
          :"Velo__Time_Zone__c"                        => @velo__time_zone__c,
          :"Velo__Transfer_History_To__c"              => @velo__transfer_history_to__c,
          :"Velo__Velocify_Lead_Import_External_ID__c" => @velo__velocify_lead_import_external_id__c,
          :"Velocify_Action__c"                        => @velocify_action__c,
          :"Velocify_Owner__c"                         => @velocify_owner__c,
          :"Website"                                   => @website,
          :"WhenSelling__c"                            => @whenselling__c,
          :"Working_With_Realtor__c"                   => @working_with_realtor__c,
          :"session_uuid__c"                           => @session_uuid__c
        }.select{ |k,v| !v.nil? }

        AFCSalesforce::DataTruncator.truncate_hash(salesforce_hash)
      end
    end
  end
end
