module AFCSalesforce
  module Tools
    module Validation
      module Rule
        # Rule for instance of
        class InstanceOf
          def initialize(instance_name)
            @instance_name = instance_name
          end

          def params
            @instance_name
          end

          def error(value)
            results            = {}
            results[:expected] = @instance_name
            results[:got]      = value.class
            results
          end

          # Determines if value is empty or not. In this rule, nil is empty
          def valid_value?(value)
            return true if value.nil?
            value.class == @instance_name
          end

          # The error key for this field
          def error_key
            :instance_of
          end
        end
      end
    end
  end
end